Attribute VB_Name = "formsubs"
Type ControlProportions
    WidthProportions As Single
    HeightProportions As Single
    TopProportions As Single
    LeftProportions As Single
End Type

Dim ArrayProportions() As ControlProportions

Public Sub getcontrols(ByVal frmForm As Form)
    ' work variable
    Dim i As Integer

    ReDim ArrayProportions(frmForm.Controls.Count)
    
    With frmForm
        ' loop through all the controls on the form
        For i = 0 To frmForm.Controls.Count - 1
            ' Ignore invisible controls
            If TypeOf frmForm.Controls(i) Is Timer Then
                ' skip this one
            'ElseIf TypeOf frmForm.Controls(i) Is ComCtl2 Then
                ' skip this one
            Else
                With ArrayProportions(i)
                    .WidthProportions = frmForm.Controls(i).Width / frmForm.ScaleWidth
                    .HeightProportions = frmForm.Controls(i).Height / frmForm.ScaleHeight
                    .LeftProportions = frmForm.Controls(i).Left / frmForm.ScaleWidth
                    .TopProportions = frmForm.Controls(i).Top / frmForm.ScaleHeight
                End With
            End If
        Next i
    End With
End Sub

Public Sub form_resize(frmForm As Form)
    ' work variable
    Dim i As Integer
    
    ' loop through all the controls on the form
    For i = 0 To frmForm.Controls.Count - 1
        ' Ignore invisible controls
        If TypeOf frmForm.Controls(i) Is Timer Then
            ' skip this one
        'ElseIf TypeOf frmForm.Controls(i) Is ComCtl2 Then
            ' skip this one
        Else
            ' Move the controls to where they should be,
            ' resizing them to match the resolution of the screen
            frmForm.Controls(i).Move _
            ArrayProportions(i).LeftProportions * ScaleWidth, _
            ArrayProportions(i).TopProportions * ScaleHeight, _
            ArrayProportions(i).WidthProportions * ScaleWidth, _
            ArrayProportions(i).HeightProportions * ScaleHeight
        End If
    Next i
            
End Sub

Public Sub ClearAllControls(frmForm As Form)

    Dim ctlControl As Control
    ' Initialize all controls that can be initialized
    ' Any control with a text property or a list-index property
    On Error Resume Next
    For Each ctlControl In frmForm.Controls
        If TypeOf ctlControl Is TextBox Then
            ctlControl.Text = ""
        End If
        
        If TypeOf ctlControl Is ComboBox Then
            ctlControl.ListIndex = -1
        End If
        
        DoEvents
    Next ctlControl
    
End Sub

