VERSION 5.00
Begin VB.Form login 
   Caption         =   "CICS Logon"
   ClientHeight    =   4305
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5295
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   4305
   ScaleWidth      =   5295
   StartUpPosition =   3  'Windows Default
   Begin VB.ComboBox cics_system 
      Height          =   315
      Left            =   1800
      TabIndex        =   3
      ToolTipText     =   "Select the CICS system to connect to"
      Top             =   1080
      Width           =   1335
   End
   Begin VB.CommandButton Cancel 
      Caption         =   "Cancel"
      Height          =   495
      Left            =   2040
      TabIndex        =   6
      ToolTipText     =   "Exit from the applicaition"
      Top             =   3000
      Width           =   1215
   End
   Begin VB.CommandButton Logon 
      Caption         =   "Logon to CICS"
      Default         =   -1  'True
      Height          =   495
      Left            =   360
      TabIndex        =   5
      ToolTipText     =   "Validate the user id and password"
      Top             =   3000
      Width           =   1215
   End
   Begin VB.TextBox cics_error_msg 
      Height          =   285
      Left            =   840
      TabIndex        =   10
      TabStop         =   0   'False
      ToolTipText     =   "Error messages"
      Top             =   2160
      Width           =   4215
   End
   Begin VB.TextBox network_name 
      Height          =   285
      Left            =   1800
      MaxLength       =   8
      TabIndex        =   4
      ToolTipText     =   "Network name of CICS terminal (max 8 chars - optional)"
      Top             =   1440
      Width           =   1335
   End
   Begin VB.TextBox cics_pw 
      Height          =   285
      IMEMode         =   3  'DISABLE
      Left            =   1800
      MaxLength       =   8
      PasswordChar    =   "*"
      TabIndex        =   2
      ToolTipText     =   "Enter CICS password (max 8 chars)"
      Top             =   720
      Width           =   855
   End
   Begin VB.TextBox cics_user 
      Height          =   285
      Left            =   1800
      MaxLength       =   8
      TabIndex        =   1
      ToolTipText     =   "Enter CICS user id (max 8 chars)"
      Top             =   360
      Width           =   855
   End
   Begin VB.Label Label4 
      Caption         =   "Network Name"
      Height          =   255
      Left            =   360
      TabIndex        =   9
      Top             =   1455
      Width           =   1095
   End
   Begin VB.Label Label3 
      Caption         =   "CICS System"
      Height          =   255
      Left            =   360
      TabIndex        =   8
      Top             =   1095
      Width           =   975
   End
   Begin VB.Label Label2 
      Caption         =   "Password"
      Height          =   255
      Left            =   360
      TabIndex        =   7
      Top             =   735
      Width           =   735
   End
   Begin VB.Label Label1 
      Caption         =   "User ID"
      Height          =   255
      Left            =   360
      TabIndex        =   0
      Top             =   375
      Width           =   615
   End
End
Attribute VB_Name = "login"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' location of trace file
Const tracefile = "c:\temp\epitrace.txt"
Const trcinq = 0
Const trcon = 1
Const trcappend = 2
Const trcoff = 3
Const trctimes = 4
Const trlevelmin = 0
Const trlevelsome = 1
Const trlevelmax = 2

Public ca_user As String
Public ca_system As String

Public term3270 As api3270
Dim terminst As String

Private Sub Cancel_Click()
    Unload Me
End Sub

Private Sub Form_Load()
    ' Working variables
    Dim i As Integer
    Dim j As Integer
    Dim ServName As String
 
    getcontrols login
 
    ' Create the EPI 3270 terminal object object
    Set term3270 = New api3270
    
    ' Get the list of CICS servers from the client and add them to the listbox
    i = 0
    j = term3270.ServerCount
    While i < j
        ' Get the server name
        ServName = term3270.ServerName(i)

        ' Set the default server name
        If i = 0 Then
            cics_system.Text = ServName
        End If
   
        ' Add it to the combo box
        cics_system.AddItem ServName, i
   
        ' move on to the next defined server
        i = i + 1
    Wend
    
    terminst = ""
    
    ' turn trace on
    trace_on
    
    ' Load the screen image form
    Load Screen
    Screen.Show
End Sub


Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    ' delete the EPI screen object we created
    Set term3270 = Nothing
    
    ' end the program
    End
End Sub

Private Sub Logon_Click()
    Dim rc As Integer
    Dim eventype As Variant
    Dim tran As String
    Dim nxtran As String
    Dim error_msg
    Dim checksum As Integer
    Dim fields As Integer
    Dim screendata As Variant
    Dim s As String
 
    ' Initialize variables
    eventype = 0
    
    ' Check if we already have a terminal
    If terminst = "" Then
        ' create a terminal for the selected region
        rc = term3270.CreateTerminal(cics_system.Text, network_name.Text, "")
        ' were we able to install the terminal?
        If rc <> 0 Then
            error_msg = "Cannot create terminal - return code " + term3270.EPIErrorMessage(rc)
        Else
            ' remember what system we are connected to
            terminst = cics_system.Text
        End If
    Else
        ' Initialize the return code
        rc = 0
    End If
            
    If terminst <> "" And rc = 0 Then
        ' try to run the sign on (CESN) transaction
        rc = run_signon
            
        ' check if the screen was formatted
        ' I have no idea why sign on does not seem to be
        ' formatting the screen the first time but this
        ' does bypass the bug
        If rc = 0 And term3270.numberFields = 0 Then
            rc = run_signon
        End If
    
        checksum = term3270.GetScreenSum
        ' check if we have the right screen
        If checksum = 17517 Or checksum = 14061 Then
            ' Fill in the sign on data
            ' Enter the user id
            rc = term3270.ModifyUnprotFieldNum(1, cics_user.Text)
            ' Enter the password
            rc = term3270.ModifyUnprotFieldNum(2, cics_pw.Text)
    
            ' update the screen view form
            Screen.Update_Screen_View
        
            ' Execute the sign on transaction
            ' First, see if we are in a conversational transaction
            tran = term3270.transid
        
            If tran = "CESN" Then
                rc = term3270.SendInput("ENTER")
            Else
                nxtran = term3270.nextransid
                rc = term3270.BeginTran("CESN", "ENTER")
            End If
        
            If rc = 0 Then
                ' wait for either an end transaction or a converse event
                rc = term3270.WaitEvent(eventype)
            
                ' update the screen view form
                Screen.Update_Screen_View

                If rc <> 0 Then
                    error_msg = "Error with Wait Event - " + term3270.EPIErrorMessage(rc)
                End If
            Else
                error_msg = "Unable to run sign on transaction - " + term3270.EPIErrorMessage(rc)
            End If
        
            If rc = 0 Then
                fields = term3270.numberFields
                checksum = term3270.GetScreenSum
                ' check if the sign on worked
                If fields = 0 Then
                    ' get the message from CICS
                    rc = term3270.GetDataAtLoc(0, 0, 50, screendata)
                Else
                    If fields = 2 And checksum = 3761 Then
                        ' get the message from CICS
                        rc = term3270.GetDataAtLoc(23, 1, 50, screendata)
                    Else
                        ' Get the message from CESN
                        rc = term3270.GetFieldDataNum(19, error_msg)
                    End If
                End If

                ' clear the screen
                term3270.ClearScreen
            
                ' update the screen view form
                Screen.Update_Screen_View
                
                ' check if there is a transaction running
                If term3270.transid <> "" Then
                    rc = term3270.WaitEvent(eventype)
            
                    ' update the screen view form
                    Screen.Update_Screen_View
                End If
            End If
        
            ' check that the sign on worked
            If rc = 0 And ((fields = 0 And checksum = 0) Or (fields = 2 And checksum = 3761)) Then
                ' Set the variables in the detail form
                detail.detterminal.Text = term3270.termname
                detail.detuserid.Text = cics_user.Text
                detail.detregion.Text = cics_system.Text
            
                ' Save the system and userid variables
                ca_user = cics_user.Text
                ca_system = cics_system.Text
        
                ' load the detail form and display it
                Load detail
                detail.Show
            Else
                cics_error_msg.Text = error_msg
            End If
        End If
    Else
        cics_error_msg.Text = "Incorrect screen - Not signon"
    End If
    
End Sub

Private Function run_signon() As Integer
    Dim rc As Integer
    Dim eventype As Variant
    
    ' Initialize variables
    eventype = 0
    
    ' update the screen view form
    Screen.Update_Screen_View
            
    ' clear the screen
    term3270.ClearScreen
            
    ' update the screen view form
    Screen.Update_Screen_View
            
    ' type a transaction code
    term3270.keyin ("&HOCESN")
            
    ' update the screen view form
    Screen.Update_Screen_View
            
    ' Execute the CESN transaction
    rc = term3270.BeginTran("CESN", "ENTER")
    
    ' did it work?
    If rc = 0 Then
        ' wait for either an end transaction or a converse event
        rc = term3270.WaitEvent(eventype)
        If rc <> 0 Then
            error_msg = "Error with Wait Event - return code " + Str$(rc)
        End If
    Else
        error_msg = "Unable to run sign on transaction - return code " + Str$(rc)
    End If
            
    ' update the screen view form
    Screen.Update_Screen_View
    
    run_signon = rc
End Function
Public Sub trace_on()
    Dim rc As Integer
    ' First, request date and time stamps
    rc = term3270.SetTrace(trctimes, "")
    
    ' Open the trace file overwriting any
    ' existing file
    rc = term3270.SetTrace(trcon, tracefile)
End Sub

Public Sub trace_append()
    Dim rc As Integer
    ' First, request date and time stamps
    rc = term3270.SetTrace(trctimes, "")
    
    ' Open the trace file for append
    rc = term3270.SetTrace(trcappend, tracefile)
End Sub
Public Sub trace_off()
    Dim rc As Integer
    rc = term3270.SetTrace(trcoff, tracefile)
End Sub

