VERSION 5.00
Begin VB.Form terminal 
   Caption         =   "CICS Terminal Characteristics"
   ClientHeight    =   3915
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5235
   LinkTopic       =   "Form1"
   ScaleHeight     =   3915
   ScaleWidth      =   5235
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton traceapp 
      Caption         =   "App"
      Height          =   615
      Left            =   2280
      TabIndex        =   13
      Top             =   3120
      Width           =   495
   End
   Begin VB.CommandButton traceoff 
      Caption         =   "Off"
      Enabled         =   0   'False
      Height          =   615
      Left            =   2760
      TabIndex        =   12
      Top             =   3120
      Width           =   495
   End
   Begin VB.TextBox trcfile 
      Height          =   375
      Left            =   360
      TabIndex        =   10
      Top             =   2160
      Width           =   4455
   End
   Begin VB.CommandButton traceon 
      Caption         =   "On"
      Height          =   615
      Left            =   1800
      TabIndex        =   9
      ToolTipText     =   "Enable or Disable Tracing"
      Top             =   3120
      Width           =   495
   End
   Begin VB.ComboBox CICS_System 
      Height          =   315
      Left            =   480
      TabIndex        =   8
      ToolTipText     =   "CICS Region to connect to (CICSCLI.INI)"
      Top             =   1320
      Width           =   1335
   End
   Begin VB.TextBox model_term 
      Height          =   375
      Left            =   3600
      MaxLength       =   8
      TabIndex        =   7
      Top             =   1320
      Width           =   1215
   End
   Begin VB.CommandButton exit 
      Caption         =   "E&xit"
      Height          =   615
      Left            =   3840
      TabIndex        =   5
      Top             =   3120
      Width           =   1215
   End
   Begin VB.CommandButton proc_term 
      Caption         =   "&Create Terminal"
      Default         =   -1  'True
      Height          =   615
      Left            =   360
      TabIndex        =   4
      ToolTipText     =   "Create the CICS Terminal"
      Top             =   3120
      Width           =   1095
   End
   Begin VB.TextBox netname 
      Height          =   375
      Left            =   2160
      MaxLength       =   8
      TabIndex        =   1
      Top             =   1320
      Width           =   1095
   End
   Begin VB.Label Label6 
      Caption         =   "Turn Trace On/Append/Off"
      Height          =   255
      Left            =   1560
      TabIndex        =   14
      Top             =   2760
      Width           =   2175
   End
   Begin VB.Label Label5 
      Caption         =   "Trace File Name"
      Height          =   255
      Left            =   1920
      TabIndex        =   11
      Top             =   1800
      Width           =   1335
   End
   Begin VB.Label Label4 
      Caption         =   "Model Terminal"
      Height          =   255
      Left            =   3600
      TabIndex        =   6
      Top             =   960
      Width           =   1095
   End
   Begin VB.Label Label3 
      Caption         =   "CICS System"
      Height          =   255
      Left            =   600
      TabIndex        =   3
      Top             =   960
      Width           =   975
   End
   Begin VB.Label Label2 
      Caption         =   "Network Name"
      Height          =   255
      Left            =   2160
      TabIndex        =   2
      Top             =   960
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "Create CICS EPI Terminal"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   840
      TabIndex        =   0
      Top             =   120
      Width           =   3495
   End
End
Attribute VB_Name = "terminal"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Default trace file name
Const tracefilename = "c:\temp\epitrace.txt"

Public exitbutton As Integer

Private Sub exit_Click()
    exitbutton = 1
    Me.Hide
End Sub

Private Sub proc_term_Click()
    exitbutton = 0
    Me.Hide
End Sub

Private Sub form_load()
    Dim i As Integer
    Dim j As Integer
    Dim ServName As String
    
    ' Initialize the trace variables
    trcfile.Text = tracefilename
    Main.tracefile = trcfile.Text
    
    ' Get the list of CICS servers from the client and add them to the listbox
    i = 0
    j = Main.term3270.ServerCount
    While i < j
        ' Get the server name
        ServName = Main.term3270.ServerName(i)

        ' Set the default server name
        If i = 0 Then
            CICS_System.Text = ServName
        End If

        ' Add it to the combo box
        CICS_System.AddItem ServName, i

        ' move on to the next defined server
        i = i + 1
    Wend
End Sub

Private Sub traceapp_Click()
    ' Don't allow changes to the file name while trace is on
    trcfile.Locked = True
    
    ' Set the file name
    Main.tracefile = trcfile.Text
        
    ' Disable the on button
    traceon.Enabled = False
    traceapp.Enabled = False
    
    ' Disable the off button
    traceoff.Enabled = True
    
    ' Start the trace, appending to the current file
    Main.trace_append
End Sub

Private Sub traceon_Click()
    ' Don't allow changes to the file name while trace is on
    trcfile.Locked = True
    
    ' Set the file name
    Main.tracefile = trcfile.Text
        
    ' Disable the on button
    traceon.Enabled = False
    traceapp.Enabled = False
    
    ' Disable the off button
    traceoff.Enabled = True
    
    ' Turn trace on
    Main.trace_on
End Sub

Private Sub traceoff_Click()
    ' Don't allow changes to the file name while trace is on
    trcfile.Locked = False
        
    ' Enable the on and append buttons
    traceon.Enabled = True
    traceapp.Enabled = True
    
    ' Disable the off button
    traceoff.Enabled = False
        
    ' Turn trace off
    Main.trace_off
End Sub

Private Sub trcfile_Change()
    ' Keep the main trace file name up to date
    Main.tracefile = trcfile.Text
End Sub
